function iu_GetHttpRequestObject() {
	var xhr = null;
	try {
		xhr = new XMLHttpRequest(); 
	}
	catch(e) { 
		try {
			xhr = new ActiveXObject("Msxml2.XMLHTTP");
		}
		catch (e2) {
			try {
				xhr = new ActiveXObject("Microsoft.XMLHTTP");
			}
			catch (e) {}
		}
	}
	if (xhr == null && window.createRequest) {
		try {
			xmlhttp = window.createRequest();
		}
		catch (e) {}
	}
	return xhr;
}

function iu_RunWPFileBaseHttpRequest(filebaseurl) {
	var xmlhttp = iu_GetHttpRequestObject();
	if (xmlhttp == null) return;

	xmlhttp.open("GET", filebaseurl, false);
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4) {
		}
	}
	xmlhttp.send(null);
}

function iu_FormButtonPressed(shortcode_id) {
	var xmlhttp = iu_GetHttpRequestObject();
	if (xmlhttp == null) return;

	xmlhttp.open("GET", "/wp-content/plugins/inline-upload/iu_response.php?shortcode_id=" + shortcode_id, false);
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4) {
		}
	}
	xmlhttp.send(null);
}

function iu_Redirect(link) {
	window.location = link;
}

function iu_uploadProgress(evt) {
	if (evt.lengthComputable) {
		var progbar_width = document.getElementById('progressbar_' + this.shortcode_id).clientWidth;
		if (progbar_width == 0) progbar_width = document.getElementById('progressbar_' + this.shortcode_id).offsetWidth;
		progbar_width -= 2;
		var percentComplete = Math.round(evt.loaded * progbar_width / evt.total);
		document.getElementById('progressbar_' + this.shortcode_id + '_inner').style.width = percentComplete.toString() + 'px';
	}
	else {
		document.getElementById('progressbar_' + this.shortcode_id + '_inner').style.width = '0px';
	}
}

function iu_uploadComplete(evt) {
	JSONtext = iu_plugin_decode_string(evt.target.responseText);
	var JSONobj = JSON.parse(JSONtext);
	document.getElementById('progressbar_' + JSONobj.shortcode_id).className = 'file_progress_bar_hidden';
	document.getElementById('progressbar_' + JSONobj.shortcode_id + '_inner').className = 'file_progress_bar_inner_hidden';
	document.getElementById('messagelabel_' + JSONobj.shortcode_id).innerHTML = JSONobj.message;
	document.getElementById('messagelabel_' + JSONobj.shortcode_id).style.color = JSONobj.color;
	document.getElementById('messagelabel_' + JSONobj.shortcode_id).style.visibility = 'visible';
	document.getElementById('fileName_' + JSONobj.shortcode_id).value = '';
}

function iu_uploadFailed(evt) {
	alert("There was an error attempting to upload the file.");
}

function iu_uploadCanceled(evt) {
	alert("The upload has been canceled by the user or the browser dropped the connection.");
} 

function iu_plugin_decode_string(str) {
	var i = 0;
	var newstr = "";
	var hex = "";
	for (i = 0; i < str.length; i += 2) {
		hex = str[i] + str[i + 1];
		newstr += String.fromCharCode(parseInt(hex, 16));
	}
	return newstr;
}

function iu_redirect_to_classic(shortcode_id) {
	iu_FormButtonPressed(shortcode_id);
	document.getElementById('upfile_' + shortcode_id).name = 'uploadedfile_' + shortcode_id + '_redirected';
	document.getElementById('uploadform_' + shortcode_id).submit();
}

function iu_HTML5UploadFile(sid, JSONtext) {
	var xhr = iu_GetHttpRequestObject();
	if (xhr == null) {
		iu_redirect_to_classic(sid);
		return;
	}

	JSONtext = iu_plugin_decode_string(JSONtext);
	var JSONobj = null;
	try {
		var JSONobj = JSON.parse(JSONtext);
	}
	catch(e) {}
	if (JSONobj == null) {
		iu_redirect_to_classic(sid);
		return;
	}

	var fd = null;
	try {
		var fd = new FormData();
	}
	catch(e) {}
	if (fd == null) {
		iu_redirect_to_classic(sid);
		return;
	}

	var subdir_sel_index = -1;
	if (document.getElementById('selectsubdir_' + sid) != null)
		subdir_sel_index = document.getElementById('selectsubdir_' + sid).selectedIndex;

	fd.append("uploadedfile_" + sid, document.getElementById('upfile_' + sid).files[0]);
	fd.append("action", "iu_ajax_action");
	fd.append("params_index", JSONobj.params_index);
	fd.append("subdir_sel_index", subdir_sel_index);

	// event listners
	xhr.upload.shortcode_id = sid;
	xhr.upload.addEventListener("progress", iu_uploadProgress, false);
	xhr.addEventListener("load", iu_uploadComplete, false);
	xhr.addEventListener("error", iu_uploadFailed, false);
	xhr.addEventListener("abort", iu_uploadCanceled, false);

	document.getElementById('progressbar_' + sid).className = 'file_progress_bar';
	document.getElementById('progressbar_' + sid + '_inner').className = 'file_progress_bar_inner';

	xhr.open("POST", "/wp-admin/admin-ajax.php");
	xhr.send(fd);
}

